//*  SwarmSpawn Mutator v2.0(c) 2016 MrLoathsome   *//
//*  Spawns Swarms of Actors into any map. + More  *//

class SS expands Mutator config(SwarmSpawn);

var config float CheckRate;
var config bool bDebugMode;

struct SSetType
{
	var String SName;
	var String SVal;
};

struct SwarmInfoType
{
	var String SwarmClass;
	var int Qty;
	var float SDS;
	var bool bSpawnOnce;
	var bool bSkipPreCache;
	var bool bHorde;
	var SSetType SSet0;
	var SSetType SSet1;
	var SSetType SSet2;
	var SSetType SSet3;
	var SSetType SSet4;
	var SSetType SSet5;
	var SSetType SSet6;
	var SSetType SSet7;
	var SSetType SSet8;
	var SSetType SSet9;
	var SSetType SSet10;
	var SSetType SSet11;
	var SSetType SSet12;
	var SSetType SSet13;
	var SSetType SSet14;
	var SSetType SSet15;
};

var config SwarmInfoType SwarmInfo[256];

var Vector SpawnLocs[4096];
var int SpawnLocCount, NumSwarms, CurSwarm, ActiveSwarms, INeededPawns, SPawnCount, FScnt, SetCntTot[256], RetryCnt[256];
var class<Actor> SwarmClasses[256];

var string SetName[4096];
var bool bQtyZero, bFirstSpawn;

function PostBeginPlay()
{
   local NavigationPoint N;
   local Inventory Inv;
   local int i, j, k, QtyHold;
   local class<Actor> aC;
   local Actor SWtmp;
   local vector L;

	Super.PostBeginPlay();

	for (N = Level.NavigationPointList; N != NONE; N = N.NextNavigationPoint)
	{
		if ((N.IsA('PathNode') || N.IsA('SpawnPoint') || N.IsA('PlayerStart')) && (!N.Region.Zone.bWaterZone || !N.Region.Zone.bPainZone))
		{
			if (SpawnLocCount <= 4095)
			{
				SWtmp = spawn(class'UnrealI.SkaarjWarrior',,,N.Location);
				if (SWtmp != None)
				{
					SpawnLocs[SpawnLocCount] = N.Location;
					SpawnLocCount++;
					SWtmp.Destroy();
					N.bPlayerOnly = False;
				}
			}
		}
	}

	forEach AllActors(class'Inventory', Inv)
	{
		if ((!Inv.Region.Zone.bWaterZone) && (!Inv.Region.Zone.bPainZone))
		{
			if (SpawnLocCount <= 4095)
			{
				L = Inv.Location;
				SWtmp = spawn(class'UnrealI.SkaarjWarrior',,,L);
				if (SWtmp != None)
				{
					SpawnLocs[SpawnLocCount] = Inv.Location;
					SpawnLocCount++;
					SWtmp.Destroy();
				}

			}
		}
	}

	PreCacheLists();
	bQtyZero = False;
	log("SwarmSpawn: Begin Init - Spawnpoint count: "$SpawnLocCount@" Number Swarms: "$NumSwarms);
	if (SpawnLocCount >= 1)
	{
		if (NumSwarms > 0)
		{
			for (i = 0; i < NumSwarms; i++)
			{
				if (!SwarmInfo[i].bSkipPreCache && ((SwarmInfo[i].bSpawnOnce) || (SwarmInfo[i].Qty == 0)))
				{
					aC = class<Actor>(DynamicLoadObject(SwarmInfo[i].SwarmClass, class'Class'));
					if (bDebugMode) { log("SwarmSpawn: Swarm #"$i@aC); }
					if (SwarmInfo[i].Qty == 0)
						{ QtyHold = 1; bQtyZero = True; SwarmInfo[i].Qty = 1; }
					else QtyHold = SwarmInfo[i].Qty;
					if (!SwarmInfo[i].bHorde) SwarmInfo[i].Qty = 1;
					INeededPawns = SwarmInfo[i].Qty;
					for (k = 0; k < QtyHold; k++)
					{
						SpawnSwarm(aC, i);
						if (SwarmInfo[i].bHorde) break;
					}
					if (bQtyZero) SwarmInfo[i].Qty = 0; else SwarmInfo[i].Qty = QtyHold;
					bQtyZero = False;
					j++;
				}
			}
			ActiveSwarms = NumSwarms - j;
			bFirstSpawn = True;
			if (ActiveSwarms == NumSwarms)
				SetTimer(CheckRate, true);
			else
				SetTimer(3.0, true);
		}
	}
	log("SwarmSpawn: End Init - Number Active Swarms: "$ActiveSwarms);
}

function PreCacheLists()
{
	local int i, j, k, x;
	local class<Actor> aC, tC;
	local Actor pcla;

	if (bDebugMode) log("SwarmSpawn: Begin PreCacheLists");
	for (i=0; i<256; i++)
	{
		if (SwarmInfo[i].SwarmClass == "") break;
		aC = None;
		aC = class<Actor>(DynamicLoadObject(SwarmInfo[i].SwarmClass, class'Class'));
		if (aC == None) { log("SwarmSpawn Init - Bad Class: "$SwarmInfo[i].SwarmClass); break; }

		if (SwarmInfo[i].SDS == 0.0) SwarmInfo[i].SDS = 1.0;
		if (!SwarmInfo[i].bSkipPreCache)
			pcla = spawn(aC,,,SpawnLocs[Rand(SpawnLocCount)]);

		if ((pcla != None) || (SwarmInfo[i].bSkipPreCache))
		{
			SwarmClasses[i] = aC;
			for (j = 0; j<16; j++)
			{
				switch(j) {
					case 15: if (SwarmInfo[i].SSet15.SName != "")
					{
						SetCntTot[i]++;
						if (SwarmInfo[i].Qty == 0)
						{
							SetName[k] = "Set"@aC@SwarmInfo[i].SSet15.SName@SwarmInfo[i].SSet15.SVal;
							ConsoleCommand(SetName[k]);
						}
					} break;
					case 14: if (SwarmInfo[i].SSet14.SName != "")
					{
						SetCntTot[i]++;
						if (SwarmInfo[i].Qty == 0)
						{
							SetName[k] = "Set"@aC@SwarmInfo[i].SSet14.SName@SwarmInfo[i].SSet14.SVal;
							ConsoleCommand(SetName[k]);
						}
					} break;
					case 13: if (SwarmInfo[i].SSet13.SName != "")
					{
						SetCntTot[i]++;
						if (SwarmInfo[i].Qty == 0)
						{
							SetName[k] = "Set"@aC@SwarmInfo[i].SSet13.SName@SwarmInfo[i].SSet13.SVal;
							ConsoleCommand(SetName[k]);
						}
					} break;
					case 12: if (SwarmInfo[i].SSet12.SName != "")
					{
						SetCntTot[i]++;
						if (SwarmInfo[i].Qty == 0)
						{
							SetName[k] = "Set"@aC@SwarmInfo[i].SSet12.SName@SwarmInfo[i].SSet12.SVal;
							ConsoleCommand(SetName[k]);
						}
					} break;
					case 11: if (SwarmInfo[i].SSet11.SName != "")
					{
						SetCntTot[i]++;
						if (SwarmInfo[i].Qty == 0)
						{
							SetName[k] = "Set"@aC@SwarmInfo[i].SSet11.SName@SwarmInfo[i].SSet11.SVal;
							ConsoleCommand(SetName[k]);
						}
					} break;
					case 10: if (SwarmInfo[i].SSet10.SName != "")
					{
						SetCntTot[i]++;
						if (SwarmInfo[i].Qty == 0)
						{
							SetName[k] = "Set"@aC@SwarmInfo[i].SSet10.SName@SwarmInfo[i].SSet10.SVal;
							ConsoleCommand(SetName[k]);
						}
					} break;
					case 9: if (SwarmInfo[i].SSet9.SName != "")
					{
						SetCntTot[i]++;
						if (SwarmInfo[i].Qty == 0)
						{
							SetName[k] = "Set"@aC@SwarmInfo[i].SSet9.SName@SwarmInfo[i].SSet9.SVal;
							ConsoleCommand(SetName[k]);
						}
					} break;
					case 8: if (SwarmInfo[i].SSet8.SName != "")
					{
						SetCntTot[i]++;
						if (SwarmInfo[i].Qty == 0)
						{
							SetName[k] = "Set"@aC@SwarmInfo[i].SSet8.SName@SwarmInfo[i].SSet8.SVal;
							ConsoleCommand(SetName[k]);
						}
					} break;
					case 7: if (SwarmInfo[i].SSet7.SName != "")
					{
						SetCntTot[i]++;
						if (SwarmInfo[i].Qty == 0)
						{
							SetName[k] = "Set"@aC@SwarmInfo[i].SSet7.SName@SwarmInfo[i].SSet7.SVal;
							ConsoleCommand(SetName[k]);
						}
					} break;
					case 6: if (SwarmInfo[i].SSet6.SName != "")
					{
						SetCntTot[i]++;
						if (SwarmInfo[i].Qty == 0)
						{
							SetName[k] = "Set"@aC@SwarmInfo[i].SSet6.SName@SwarmInfo[i].SSet6.SVal;
							ConsoleCommand(SetName[k]);
						}
					} break;
					case 5: if (SwarmInfo[i].SSet5.SName != "")
					{
						SetCntTot[i]++;
						if (SwarmInfo[i].Qty == 0)
						{
							SetName[k] = "Set"@aC@SwarmInfo[i].SSet5.SName@SwarmInfo[i].SSet5.SVal;
							ConsoleCommand(SetName[k]);
						}
					} break;
					case 4: if (SwarmInfo[i].SSet4.SName != "")
					{
						SetCntTot[i]++;
						if (SwarmInfo[i].Qty == 0)
						{
							SetName[k] = "Set"@aC@SwarmInfo[i].SSet4.SName@SwarmInfo[i].SSet4.SVal;
							ConsoleCommand(SetName[k]);
						}
					} break;
					case 3: if (SwarmInfo[i].SSet3.SName != "")
					{
						SetCntTot[i]++;
						if (SwarmInfo[i].Qty == 0)
						{
							SetName[k] = "Set"@aC@SwarmInfo[i].SSet3.SName@SwarmInfo[i].SSet3.SVal;
							ConsoleCommand(SetName[k]);
						}
					} break;
					case 2: if (SwarmInfo[i].SSet2.SName != "")
					{
						SetCntTot[i]++;
						if (SwarmInfo[i].Qty == 0)
						{
							SetName[k] = "Set"@aC@SwarmInfo[i].SSet2.SName@SwarmInfo[i].SSet2.SVal;
							ConsoleCommand(SetName[k]);
						}
					} break;
					case 1: if (SwarmInfo[i].SSet1.SName != "")
					{
						SetCntTot[i]++;
						if (SwarmInfo[i].Qty == 0)
						{
							SetName[k] = "Set"@aC@SwarmInfo[i].SSet1.SName@SwarmInfo[i].SSet1.SVal;
							ConsoleCommand(SetName[k]);
						}
					} break;

					case 0: if (SwarmInfo[i].SSet0.SName != "")
					{
						SetCntTot[i]++;
						if ((SwarmInfo[i].Qty == 0) || (SwarmInfo[i].bSkipPreCache))
						{
							SetName[k] = "Set"@aC@SwarmInfo[i].SSet0.SName@SwarmInfo[i].SSet0.SVal;
							ConsoleCommand(SetName[k]);
						}
					}

				}
				if ((bDebugMode) && (SetName[k] != ""))
				{
					log("Attempting:"@SetName[k]);
				}
				k++;
			}
		}
		else if (!SwarmInfo[i].bSkipPreCache)
		{
			RetryCnt[i]++;  if (bDebugMode) log("SwarmSpawn:  Retry #"$RetryCnt[i]@"- Pre-Cache for:"@aC@"Swarm #"$i);
			if (RetryCnt[i] > 30)
			{
				log("SwarmSpawn: Precache failed for: "$aC);
				SwarmInfo[i].Qty = 0; SwarmInfo[i].bSpawnOnce = False; SwarmInfo[i].SwarmClass = "UnrealShare.SeaWeed";
			} else { i--; NumSwarms--; }
		}
		NumSwarms++;
		if ((pcla != none) && (!pcla.bDeleteMe))
			{ if (bDebugMode) log ("Destroying: "@pcla); pcla.Destroy(); }
	}
	if (bDebugMode) log("SwarmSpawn: End PreCacheLists");
	if (bDebugMode) log(".");
}

function bool SpawnPawn(class<Actor> aC, Vector Location, int SwarmNum)
{
   local Pawn NewPawn;
   local SActor tP;
   local int i, j;
   local float F;

   tP = Spawn(class'SwarmSpawn.SActor',,,Location);

   if (tP != None)
	{
		tP.AActor = Spawn(aC,,,Location);
		if (tP.AActor == None)
		{
			tP.Destroy(); return false;
		} else tp.LifeSpan = tp.AActor.LifeSpan;

	}
   else	{ return false; }

   if ((SwarmInfo[SwarmNum].SDS != 1.0) && (SwarmInfo[SwarmNum].SDS != 0.0))
   {
	F = SwarmInfo[SwarmNum].SDS;
	tP.AActor.DrawScale = tP.AActor.DrawScale * F;
	tP.AActor.Mass = tP.AActor.Mass * F;
	NewPawn = Pawn(tP.AActor);
	if (NewPawn != None)
	{
		NewPawn.GroundSpeed = NewPawn.GroundSpeed * F;
		NewPawn.WaterSpeed = NewPawn.WaterSpeed * F;
		NewPawn.AirSpeed = NewPawn.AirSpeed * F;
		NewPawn.AccelRate = NewPawn.AccelRate * F;
		NewPawn.JumpZ = NewPawn.JumpZ * F;
		NewPawn.MaxStepHeight = NewPawn.MaxStepHeight * F;
		NewPawn.MeleeRange = NewPawn.MeleeRange * F;
		NewPawn.BaseEyeHeight = NewPawn.BaseEyeHeight * F;
		NewPawn.EyeHeight = NewPawn.EyeHeight * F;
		if (ScriptedPawn(NewPawn) != None)
		   if (ScriptedPawn(NewPawn).Shadow != None)
			{ ScriptedPawn(NewPawn).Shadow.DrawScale = ScriptedPawn(NewPawn).Shadow.DrawScale * F; }
		NewPawn.Health = NewPawn.Health * F;
	}
	tP.AActor.SetCollisionSize((tP.AActor.CollisionRadius * F), (tP.AActor.CollisionHeight * F));
	tP.AActor.Buoyancy = tP.AActor.Buoyancy * F;
   }
   if (bDebugMode) log("SwarmSpawn:"@tP.AActor@"spawned....");
   for (i = 0; i<SetCntTot[SwarmNum]; i++)
   {
	switch(i) {
		case 15: if (SwarmInfo[SwarmNum].SSet15.SName != "") { tP.AActor.SetPropertyText(SwarmInfo[SwarmNum].SSet15.SName, SwarmInfo[SwarmNum].SSet15.SVal); } break;
		case 14: if (SwarmInfo[SwarmNum].SSet14.SName != "") { tP.AActor.SetPropertyText(SwarmInfo[SwarmNum].SSet14.SName, SwarmInfo[SwarmNum].SSet14.SVal); } break;
		case 13: if (SwarmInfo[SwarmNum].SSet13.SName != "") { tP.AActor.SetPropertyText(SwarmInfo[SwarmNum].SSet13.SName, SwarmInfo[SwarmNum].SSet13.SVal); } break;
		case 12: if (SwarmInfo[SwarmNum].SSet12.SName != "") { tP.AActor.SetPropertyText(SwarmInfo[SwarmNum].SSet12.SName, SwarmInfo[SwarmNum].SSet12.SVal); } break;
		case 11: if (SwarmInfo[SwarmNum].SSet11.SName != "") { tP.AActor.SetPropertyText(SwarmInfo[SwarmNum].SSet11.SName, SwarmInfo[SwarmNum].SSet11.SVal); } break;
		case 10: if (SwarmInfo[SwarmNum].SSet10.SName != "") { tP.AActor.SetPropertyText(SwarmInfo[SwarmNum].SSet10.SName, SwarmInfo[SwarmNum].SSet10.SVal); } break;
		case 9: if (SwarmInfo[SwarmNum].SSet9.SName != "") { tP.AActor.SetPropertyText(SwarmInfo[SwarmNum].SSet9.SName, SwarmInfo[SwarmNum].SSet9.SVal); } break;
		case 8: if (SwarmInfo[SwarmNum].SSet8.SName != "") { tP.AActor.SetPropertyText(SwarmInfo[SwarmNum].SSet8.SName, SwarmInfo[SwarmNum].SSet8.SVal); } break;
		case 7: if (SwarmInfo[SwarmNum].SSet7.SName != "") { tP.AActor.SetPropertyText(SwarmInfo[SwarmNum].SSet7.SName, SwarmInfo[SwarmNum].SSet7.SVal); } break;
		case 6: if (SwarmInfo[SwarmNum].SSet6.SName != "") { tP.AActor.SetPropertyText(SwarmInfo[SwarmNum].SSet6.SName, SwarmInfo[SwarmNum].SSet6.SVal); } break;
		case 5: if (SwarmInfo[SwarmNum].SSet5.SName != "") { tP.AActor.SetPropertyText(SwarmInfo[SwarmNum].SSet5.SName, SwarmInfo[SwarmNum].SSet5.SVal); } break;
		case 4: if (SwarmInfo[SwarmNum].SSet4.SName != "") { tP.AActor.SetPropertyText(SwarmInfo[SwarmNum].SSet4.SName, SwarmInfo[SwarmNum].SSet4.SVal); } break;
		case 3: if (SwarmInfo[SwarmNum].SSet3.SName != "") { tP.AActor.SetPropertyText(SwarmInfo[SwarmNum].SSet3.SName, SwarmInfo[SwarmNum].SSet3.SVal); } break;
		case 2: if (SwarmInfo[SwarmNum].SSet2.SName != "") { tP.AActor.SetPropertyText(SwarmInfo[SwarmNum].SSet2.SName, SwarmInfo[SwarmNum].SSet2.SVal); } break;
		case 1: if (SwarmInfo[SwarmNum].SSet1.SName != "") { tP.AActor.SetPropertyText(SwarmInfo[SwarmNum].SSet1.SName, SwarmInfo[SwarmNum].SSet1.SVal); } break;
		case 0: if (SwarmInfo[SwarmNum].SSet0.SName != "") { tP.AActor.SetPropertyText(SwarmInfo[SwarmNum].SSet0.SName, SwarmInfo[SwarmNum].SSet0.SVal); }
	}
   }
   if (bDebugMode)
   {
      for (i = 0; i<16; i++)
	{
	    switch(i) {
   		case 15: if (SwarmInfo[SwarmNum].SSet15.SName != "")
			 {
				log("Attempted settings: "$tP.AActor@SwarmInfo[SwarmNum].SSet15.SName@SwarmInfo[SwarmNum].SSet15.SVal);
				log("Actual values: "$tP.AActor@SwarmInfo[SwarmNum].SSet15.SName@tP.AActor.getPropertyText(SwarmInfo[SwarmNum].SSet15.SName));
				log(".");
			 } break;
   		case 14: if (SwarmInfo[SwarmNum].SSet14.SName != "")
			 {
				log("Attempted settings: "$tP.AActor@SwarmInfo[SwarmNum].SSet14.SName@SwarmInfo[SwarmNum].SSet14.SVal);
				log("Actual values: "$tP.AActor@SwarmInfo[SwarmNum].SSet14.SName@tP.AActor.getPropertyText(SwarmInfo[SwarmNum].SSet14.SName));
				log(".");
			 } break;
   		case 13: if (SwarmInfo[SwarmNum].SSet13.SName != "")
			 {
				log("Attempted settings: "$tP.AActor@SwarmInfo[SwarmNum].SSet13.SName@SwarmInfo[SwarmNum].SSet13.SVal);
				log("Actual values: "$tP.AActor@SwarmInfo[SwarmNum].SSet13.SName@tP.AActor.getPropertyText(SwarmInfo[SwarmNum].SSet13.SName));
				log(".");
			 } break;
   		case 12: if (SwarmInfo[SwarmNum].SSet12.SName != "")
			 {
				log("Attempted settings: "$tP.AActor@SwarmInfo[SwarmNum].SSet12.SName@SwarmInfo[SwarmNum].SSet12.SVal);
				log("Actual values: "$tP.AActor@SwarmInfo[SwarmNum].SSet12.SName@tP.AActor.getPropertyText(SwarmInfo[SwarmNum].SSet12.SName));
				log(".");
			 } break;
   		case 11: if (SwarmInfo[SwarmNum].SSet11.SName != "")
			 {
				log("Attempted settings: "$tP.AActor@SwarmInfo[SwarmNum].SSet11.SName@SwarmInfo[SwarmNum].SSet11.SVal);
				log("Actual values: "$tP.AActor@SwarmInfo[SwarmNum].SSet11.SName@tP.AActor.getPropertyText(SwarmInfo[SwarmNum].SSet11.SName));
				log(".");
			 } break;
   		case 10: if (SwarmInfo[SwarmNum].SSet10.SName != "")
			 {
				log("Attempted settings: "$tP.AActor@SwarmInfo[SwarmNum].SSet10.SName@SwarmInfo[SwarmNum].SSet10.SVal);
				log("Actual values: "$tP.AActor@SwarmInfo[SwarmNum].SSet10.SName@tP.AActor.getPropertyText(SwarmInfo[SwarmNum].SSet10.SName));
				log(".");
			 } break;
   		case 9: if (SwarmInfo[SwarmNum].SSet9.SName != "")
			 {
				log("Attempted settings: "$tP.AActor@SwarmInfo[SwarmNum].SSet9.SName@SwarmInfo[SwarmNum].SSet9.SVal);
				log("Actual values: "$tP.AActor@SwarmInfo[SwarmNum].SSet9.SName@tP.AActor.getPropertyText(SwarmInfo[SwarmNum].SSet9.SName));
				log(".");
			 } break;
   		case 8: if (SwarmInfo[SwarmNum].SSet8.SName != "")
			 {
				log("Attempted settings: "$tP.AActor@SwarmInfo[SwarmNum].SSet8.SName@SwarmInfo[SwarmNum].SSet8.SVal);
				log("Actual values: "$tP.AActor@SwarmInfo[SwarmNum].SSet8.SName@tP.AActor.getPropertyText(SwarmInfo[SwarmNum].SSet8.SName));
				log(".");
			 } break;
   		case 7: if (SwarmInfo[SwarmNum].SSet7.SName != "")
			 {
				log("Attempted settings: "$tP.AActor@SwarmInfo[SwarmNum].SSet7.SName@SwarmInfo[SwarmNum].SSet7.SVal);
				log("Actual values: "$tP.AActor@SwarmInfo[SwarmNum].SSet7.SName@tP.AActor.getPropertyText(SwarmInfo[SwarmNum].SSet7.SName));
				log(".");
			 } break;
   		case 6: if (SwarmInfo[SwarmNum].SSet6.SName != "")
			 {
				log("Attempted settings: "$tP.AActor@SwarmInfo[SwarmNum].SSet6.SName@SwarmInfo[SwarmNum].SSet6.SVal);
				log("Actual values: "$tP.AActor@SwarmInfo[SwarmNum].SSet6.SName@tP.AActor.getPropertyText(SwarmInfo[SwarmNum].SSet6.SName));
				log(".");
			 } break;
   		case 5: if (SwarmInfo[SwarmNum].SSet5.SName != "")
			 {
				log("Attempted settings: "$tP.AActor@SwarmInfo[SwarmNum].SSet5.SName@SwarmInfo[SwarmNum].SSet5.SVal);
				log("Actual values: "$tP.AActor@SwarmInfo[SwarmNum].SSet5.SName@tP.AActor.getPropertyText(SwarmInfo[SwarmNum].SSet5.SName));
				log(".");
			 } break;
   		case 4: if (SwarmInfo[SwarmNum].SSet4.SName != "")
			 {
				log("Attempted settings: "$tP.AActor@SwarmInfo[SwarmNum].SSet4.SName@SwarmInfo[SwarmNum].SSet4.SVal);
				log("Actual values: "$tP.AActor@SwarmInfo[SwarmNum].SSet4.SName@tP.AActor.getPropertyText(SwarmInfo[SwarmNum].SSet4.SName));
				log(".");
			 } break;
   		case 3: if (SwarmInfo[SwarmNum].SSet3.SName != "")
			 {
				log("Attempted settings: "$tP.AActor@SwarmInfo[SwarmNum].SSet3.SName@SwarmInfo[SwarmNum].SSet3.SVal);
				log("Actual values: "$tP.AActor@SwarmInfo[SwarmNum].SSet3.SName@tP.AActor.getPropertyText(SwarmInfo[SwarmNum].SSet3.SName));
				log(".");
			 } break;
   		case 2: if (SwarmInfo[SwarmNum].SSet2.SName != "")
			 {
				log("Attempted settings: "$tP.AActor@SwarmInfo[SwarmNum].SSet2.SName@SwarmInfo[SwarmNum].SSet2.SVal);
				log("Actual values: "$tP.AActor@SwarmInfo[SwarmNum].SSet2.SName@tP.AActor.getPropertyText(SwarmInfo[SwarmNum].SSet2.SName));
				log(".");
			 } break;
   		case 1: if (SwarmInfo[SwarmNum].SSet1.SName != "")
			 {
				log("Attempted settings: "$tP.AActor@SwarmInfo[SwarmNum].SSet1.SName@SwarmInfo[SwarmNum].SSet1.SVal);
				log("Actual values: "$tP.AActor@SwarmInfo[SwarmNum].SSet1.SName@tP.AActor.getPropertyText(SwarmInfo[SwarmNum].SSet1.SName));
				log(".");
			 } break;
   		case 0: if (SwarmInfo[SwarmNum].SSet0.SName != "")
			 {
				log("Attempted settings: "$tP.AActor@SwarmInfo[SwarmNum].SSet0.SName@SwarmInfo[SwarmNum].SSet0.SVal);
				log("Actual values: "$tP.AActor@SwarmInfo[SwarmNum].SSet0.SName@tP.AActor.getPropertyText(SwarmInfo[SwarmNum].SSet0.SName));
				log(".");
			 } break;
	    }
	}
   }
   tp.ASNum = SwarmNum + 1;
   tP.AActor.SetPhysics(PHYS_Falling);
   if (bQtyZero) { log("Destroying: "@tP.AActor); tP.AActor.Destroy(); tP.Destroy(); }
   return true;
}

function bool GetSpawnPoint(out Vector Location, int HordeRadius)
{
   local Actor ColActor;

	Location = SpawnLocs[Rand(SpawnLocCount)];
	foreach RadiusActors(Class'Actor', ColActor, HordeRadius, Location)
	{
		if (!ColActor.bHidden && !ColActor.bStatic) { return false; }
	}
	return true;
}

function SpawnSwarm(class<Actor> aC,  int SwarmNum)  // This function is a total rewrite of similar function in the TWZ_Zombies/Zombies5 code....
{
   local int ThisHordeSize, HordeRadius, INZ;
   local int PawnPerRow;
   local int retries,maxRetries;
   local int row, col, i, x;
   local Vector location,location2;
   local float CPCR;

   if (SwarmInfo[SwarmNum].bSkipPreCache) for (i = 0; i<SetCntTot[SwarmNum]; i++)
   {
	x = (SwarmNum * 16) + i;
	if (SetName[x] != "") { if (bDebugMode) { log("SwarmSpawn: -  Pre-Spawn class default adjustment:"@SetName[x]); } ConsoleCommand(SetName[x]); }
   }

   CPCR = (aC.default.CollisionRadius * SwarmInfo[SwarmNum].SDS) + 10.0;
   maxRetries = 10;
   retries = 0;

   if (SwarmInfo[SwarmNum].bHorde)
   {
      if (INeededPawns > SpawnLocCount)
	INZ = SpawnLocCount;
      else
	INZ = INeededPawns;
   } else INZ = 1;

      if(INZ > SwarmInfo[SwarmNum].Qty)
         ThisHordeSize = SwarmInfo[SwarmNum].Qty;
      else ThisHordeSize = INZ;
      PawnPerRow =  abs(sqrt(ThisHordeSize)+1);
      if ( Square(PawnPerRow-1) == ThisHordeSize)
         PawnPerRow--;
      HordeRadius= ( (1.4142135 * 2.5) * CPCR * (PawnPerRow * 0.5));
      while(INZ > 0)
      {
	 if (!GetSpawnPoint(Location, HordeRadius))
	 {
      	    if (retries != maxRetries)
	    {
	       retries++;
	       continue;
	    }
         }

	 retries = 0;
	 location.x = location.x - (1.25 * CPCR * (PawnPerRow-1));
	 location.y = location.y - (1.25 * CPCR * (PawnPerRow-1));

	 for (row = 1; row <= PawnPerRow; row++)
            for (col = 1;( col <= PawnPerRow && INZ > 0 && ThisHordeSize > 0 ); col++)
	    {
		location2 = location;
		location2.x += (row * CPCR * 1.25);
		location2.y += (col * CPCR * 1.25);
		location2.x += CPCR * SwarmInfo[SwarmNum].SDS;
		location2.y += CPCR * SwarmInfo[SwarmNum].SDS;
		if (SpawnPawn(aC, location2, SwarmNum))
		{
		  INZ--;
		  ThisHordeSize--;
		} else { retries++; if (retries > maxRetries) return; }
	    }
            break;
      }
      if (bDebugMode) { log("."); }
}

event Timer()
{
	local int i, j, FSDone, QtyHold;
	local SActor TP;

	SPawnCount = 0;
	if (bFirstSpawn)
	{
		FSDone = 0;
		for (i=0; i< NumSwarms; i++)
		{
			if ((SwarmInfo[i].Qty != 0) && (SwarmInfo[i].bSpawnOnce))
			{
				foreach AllActors(class'SwarmSpawn.SActor', TP)
				{
					if ((TP.AActor != None) && (TP.AActor.Class == SwarmClasses[i]) && (TP.ASNum == i + 1))
					{
						if ((Inventory(TP.AActor) != None) && (Inventory(TP.AActor).bRotatingPickup))
							TP.AActor.SetPhysics(PHYS_Rotating);
						if ((SwarmClasses[i] == TP.AActor.Class)  && (TP.AActor.Owner == None)) { SPawnCount++; }
					} else if ((TP.AActor == None) || (tP.AActor.Region.Zone.bWaterZone) || (tP.AActor.Region.Zone.bPainZone))
							{ if ((TP.AActor != None) && (!TP.AActor.bDeleteMe)) TP.AActor.Destroy(); TP.Destroy(); }
				}
				INeededPawns = SwarmInfo[i].Qty - SPawnCount;
				if (INeededPawns != 0)
				{
					if (bDebugMode) { BroadcastMessage("SwarmSpawn: Post Init - Swarm #"$i@SwarmClasses[i]@"Needs:"@INeededPawns); log("SwarmSpawn: Post Init - Swarm #"$i@SwarmClasses[i]@"Needs:"@INeededPawns); }
					if (bDebugMode) { log("SwarmSpawn: Attempting respawn of class"@SwarmClasses[i]@"that 'fell out of the world'...."); }
					RetryCnt[i]++;
					if (RetryCnt[i] > 10)
					{ 
						log("SwarmSpawn Post Init Aborting!!!  One of your Zero Qty or bSpawnOnce classes will not spawn.");
						bFirstSpawn = False; break;
					}
					QtyHold = SwarmInfo[i].Qty;
					SwarmInfo[i].Qty = INeededPawns;
					SpawnSwarm(SwarmClasses[i], i); FSDone++;
					SwarmInfo[i].Qty = QtyHold;
				}
				SPawnCount = 0;
			}
		}
		SetTimer(CheckRate, true);
		if (FSDone == 0) { bFirstSpawn = False; if (ActiveSwarms == 0) SetTimer(0.0, False); }
		return;
	}

    if (Level.Game.NumPlayers > 0)
    {
	i = CurSwarm;
	if ((i < NumSwarms) && ((SwarmInfo[i].Qty == 0) || (SwarmInfo[i].bSpawnOnce)))
	{
		CurSwarm++;
		if (CurSwarm >= NumSwarms) { CurSwarm = 0; }
		SetTimer(0.01250, True);
		return;
	}

	if (SwarmInfo[i].Qty > 0)
	{
		foreach AllActors(class'SwarmSpawn.SActor', TP)
		{
			if ((TP.AActor != None) && (Pawn(TP.AActor) != None) && (Pawn(TP.AActor).Health <= 0)) { TP.AActor.LifeSpan = 1.0; TP.LifeSpan = 1.0; }

			if (TP.AActor != None)
			{
				if ((SwarmClasses[i] == TP.AActor.Class) && (TP.ASNum == i + 1) && (Pawn(TP.AActor) != None) && (Pawn(TP.AActor).Health > 0)) { SPawnCount++; }
				else if ((SwarmClasses[i] == TP.AActor.Class) && (TP.ASNum == i + 1) && (TP.AActor.Owner == None)) { SPawnCount++; }
			} else TP.Destroy();
		}
		INeededPawns = SwarmInfo[i].Qty - SPawnCount;
		if (bDebugMode) { BroadcastMessage("SwarmSpawning Time!  Swarm #"$i@SwarmClasses[i]@"Needs:"@INeededPawns); log("SwarmSpawn: Swarm #"$i@SwarmClasses[i]@"Needs:"@INeededPawns); }
		if (INeededPawns > 0)
		{
			SpawnSwarm(SwarmClasses[i], i);
			FScnt = 0; SetTimer(CheckRate, true);
		}
		else
		{
			FScnt++;
		}
		if (FScnt >= ActiveSwarms * 2)
		{
			SetTimer(CheckRate * 4, true); // FScnt = (ActiveSwarms * 2);
		}
	}
	CurSwarm++;
	if (CurSwarm >= NumSwarms) { CurSwarm = 0; }
    }
}

defaultproperties
{
     CheckRate=1.0
     bDebugMode=False
     SwarmInfo(0)=(SwarmClass="UnrealShare.Cow",Qty=12,SDS=1.0,bSpawnOnce="False",bSkipPreCache="False",bHorde="False")
}
